      SUBROUTINE  INSERT (TARGET,LOCTAR,LENTAR,SOURCE,LOCSRC,NUMSRC)
C     (Insert Text)
C     Insert a string into another string.  The arguments are:
C
C     TARGET(*).....Packed Hollerith target string.
C     LOCTAR........Position at which insertion is to occur.
C     LENTAR........Length of target string.  It will be updated
C                   on return to LENTAR+NUMSRC.
C     SOURCE(*).....Packed Hollerith source string.
C     LOCSRC........Position in SOURCE at which the insertion string
C                   begins.
C     NUMSRC........Number of SOURCE characters to copy.
C
C     (13-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       F4MVC
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           J,           LENTAR,      MOVE
C
      INTEGER             I,           J,           LENTAR,      LOCSRC
      INTEGER             LOCTAR,      MOVE,        NUMSRC
      INTEGER             SOURCE(1),   TARGET(1)
C
      IF (.NOT.(NUMSRC .GT. 0)) GO TO 20001
      MOVE = LENTAR - LOCTAR + 1
      J = LENTAR
      I =LENTAR+MOVE
      N20004=LENTAR+1
      GO TO 20005
20004 I =-1+I
20005 IF (-(N20004-I ).LT.0) GO TO 20006
      CALL F4MVC (TARGET,J,TARGET,I,1)
      J = J - 1
      GO TO 20004
20006 CALL F4MVC (SOURCE,LOCSRC,TARGET,LOCTAR,NUMSRC)
      LENTAR = LENTAR + NUMSRC
20001 CONTINUE
C
20002 RETURN
      END
