C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.5 [06-Apr-1991]
C-fpp- Date: Wed Aug 14 11:31:24 1991
C-fpp- Directory: /export/local/sun4/plot79/prim
C-fpp- User: Nelson H.F. Beebe <beebe@csc-sun.math.utah.edu>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _BSD=1
C-fpp- Macro: _SUN=1
C-fpp- Macro: _SUN4=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      INTEGER FUNCTION  IBTAND (A,B)
C     (IBTAND)
C     Return the logical AND of A  and B.  This has 1-bits  where
C     both A and B have 1-bits, and 0-bits elsewhere.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       AND
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             AND
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             A,           B
C
C#if _HPUX
C##      IBTAND = IAND(A,B)
C#else
      IBTAND = AND(A,B)
C#endif
C
      RETURN
      END
      INTEGER FUNCTION  IBTCOM (A)
C     (IBTCOM)
C     Return the logical complement of the bit pattern stored  in
C     A.  The complement is formed by inverting all bits.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       NOT
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             NOT
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             A
C
      IBTCOM = NOT(A)
C
      RETURN
      END
      LOGICAL FUNCTION  IBTEST (BITSTR,NBIT)
C     (IBTEST)
C     Test bit number NBIT in BITSTR(*), and return .TRUE. if  it
C     is a 1-bit, and .FALSE. if it  is a 0-bit. If NBIT is  less
C     than 1, return .FALSE..
C     (12-APR-1991)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       BIT,         MOD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
C#if _HPUX
C##      LOGICAL             BTEST
C#else
      LOGICAL             BIT
C#endif
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MOD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                NWORD
C
      INTEGER             BITSTR(1),   NBIT,        NWORD
C
      IF (NBIT .GT. 0) THEN
           NWORD = 1 + (NBIT - 1)/32
C#if _HPUX
C##           IBTEST = BTEST(31 - MOD(NBIT-1,32),BITSTR(NWORD))
C#elif _AIX
C##              IBTEST = (IBITS(BITSTR(NWORD), 31 - MOD(NBIT-1,32), 1)
C##     X          .NE. 0)
C#else
           IBTEST = BIT(31 - MOD(NBIT-1,32),BITSTR(NWORD))
C#endif
      ELSE
           IBTEST = .FALSE.
      END IF
C
      RETURN
      END
      SUBROUTINE  IBTOFF (BITSTR,NBIT)
C     (IBTOFF)
C     Set bit number NBIT in BITSTR(*) to 0. If NBIT < 1, no  bit
C     will be set.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       BIC,         MOD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MOD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                NWORD
C
      INTEGER             BITSTR(1),   NBIT,        NWORD
C
      IF (NBIT .GT. 0) THEN
           NWORD = 1 + (NBIT - 1)/32
C#if _IBM_RS_6000
C##           BITSTR(NWORD) = IBCLR(BITSTR(NWORD),31 - MOD(NBIT-1,32))
C#elif _HPUX
C##           BITSTR(NWORD) = IBCLR(BITSTR(NWORD),31 - MOD(NBIT-1,32))
C#else
           CALL BIC (31 - MOD(NBIT-1,32),BITSTR(NWORD))
C#endif
      END IF
C
      RETURN
      END
      SUBROUTINE  IBTON (BITSTR,NBIT)
C     (IBTON)
C     Set bit number NBIT in BITSTR(*) to 1. If NBIT < 1, no  bit
C     will be set.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       BIS,         MOD
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MOD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                NWORD
C
      INTEGER             BITSTR(1),   NBIT,        NWORD
C
      IF (NBIT .GT. 0) THEN
           NWORD = 1 + (NBIT - 1)/32
C#if _IBM_RS_6000
C##           BITSTR(NWORD) = IBSET(BITSTR(NWORD),31 - MOD(NBIT-1,32))
C#elif _HPUX
C##           BITSTR(NWORD) = IBSET(BITSTR(NWORD),31 - MOD(NBIT-1,32))
C#else
           CALL BIS (31 - MOD(NBIT-1,32),BITSTR(NWORD))
C#endif
      END IF
C
      RETURN
      END
      INTEGER FUNCTION  IBTOR (A,B)
C     (IBTOR)
C     Return the logical OR of the bit patterns present in A  and
C     B.  1-bits are returned in  positions in which either A  or
C     B, or both, have a 1-bit.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       OR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             OR
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             A,           B
C
C#if _HPUX
C##      IBTOR = IOR(A,B)
C#else
      IBTOR = OR(A,B)
C#endif
C
      RETURN
      END
      INTEGER FUNCTION  IBTROL (WORD,NBITS)
C     (Rotate Left)
C     Return the result of rotating WORD left by abs(NBITS).
C     (21-Feb-1991)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       IABS,        IBTOR,       IBTSHL,      IBTSHR
C     EXTERNAL REFS       MOD
C
      INTEGER             WORDSZ
      PARAMETER           (WORDSZ = 32)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             IBTOR,       IBTSHL,      IBTSHR
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             IABS,        MOD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                P,           Q
C
      INTEGER             NBITS,       P,           Q,           WORD
C
      P = MOD(IABS(NBITS),WORDSZ)
      Q = WORDSZ - P
      IBTROL = IBTOR(IBTSHR(WORD,Q), IBTSHL(WORD,P))
C
      RETURN
      END
      INTEGER FUNCTION  IBTROR (WORD,NBITS)
C     (Rotate Right)
C     Return the result of rotating WORD right by abs(NBITS).
C     (21-Feb-1991)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       IABS,        IBTOR,       IBTSHL,      IBTSHR
C     EXTERNAL REFS       MOD
C
      INTEGER             WORDSZ
      PARAMETER           (WORDSZ = 32)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             IBTOR,       IBTSHL,      IBTSHR
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             IABS,        MOD
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                P,           Q
C
      INTEGER             NBITS,       P,           Q,           WORD
C
      P = MOD(IABS(NBITS),WORDSZ)
      Q = WORDSZ - P
      IBTROR = IBTOR(IBTSHR(WORD,P), IBTSHL(WORD,Q))
C
      RETURN
      END
      INTEGER FUNCTION  IBTROT (WORD,NBITS)
C     (Rotate)
C     Return the result of  rotating   WORD left (NBITS >   0) or
C     right (NBITS <= 0) by abs(NBITS).
C     (21-Feb-1991)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       IBTROL,      IBTROR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             IBTROL,      IBTROR
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             NBITS,       WORD
C
      IF (NBITS .GT. 0) THEN
           IBTROT = IBTROL(WORD,NBITS)
      ELSE
           IBTROT = IBTROR(WORD,NBITS)
      END IF
C
      RETURN
      END
      INTEGER FUNCTION  IBTSHL (A,NBIT)
C     (IBTSHL)
C     Return the bit pattern represented by A after performing  a
C     logical shift by |NBIT| bits to the left.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       IABS,        LSHIFT
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             LSHIFT
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             IABS
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             A,           NBIT
C
C#if _HPUX
C##      IBTSHL = ISHFT(A,IABS(NBIT))
C#else
      IBTSHL = LSHIFT(A,IABS(NBIT))
C#endif
C
      RETURN
      END
      INTEGER FUNCTION  IBTSHR (A,NBIT)
C     (IBTSHR)
C     Return the bit pattern represented by A after performing  a
C     logical shift by |NBIT| bits to the right.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       AND,         IABS,        RSHIFT
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             AND,         RSHIFT
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             IABS
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             A,           NBIT
C
C#if _HPUX
C##      IBTSHR = ISHFT(A,-IABS(NBIT))
C#else
      IF (IABS(NBIT) .GT. 0) THEN
          IBTSHR = RSHIFT(AND(RSHIFT(A,1),(2**30-1)+2**30),IABS(NBIT)-1)
      ELSE
          IBTSHR = A
      END IF
C#endif
C
      RETURN
      END
      INTEGER FUNCTION  IBTXOR (A,B)
C     (IBTXOR)
C     Return the exclusive OR of the bit patterns represented  by
C     A and B.  The result has 1-bits in positions where A and  B
C     have  different  bits,  and  0-bits  where  A  and  B  have
C     identical bits.
C     (12-NOV-85)
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       XOR
C
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             XOR
C- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
      INTEGER             A,           B
C
C#if _HPUX
C##      IBTXOR = IXOR(A,B)
C#else
      IBTXOR = XOR(A,B)
C#endif
C
      RETURN
      END
