      INTEGER FUNCTION  INDEXP (P1,I1,L1, P2,I2,L2)
C     (Index of Packed Substring)
C     Return the index of packed string P2[I2..I2+L2-1] in packed
C     string P1[I1..I1+L2-1].  The  index is  relative to  P1[1],
C     and on return, will either be 0, indicating that P2 was not
C     found in P1, or will  be in the range [I1..I1+L1-L2].   The
C     search starts at positions I1 in  P1 and I2 in P2, and  the
C     strings to be searched have lengths L1 and L2 starting from
C     these positions.
C     (21-JUN-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CH2,         J1,          J2
C
      INTEGER             CH2,         I1,          I2,          J1
      INTEGER             J2,          L1,          L2,          P1(1)
      INTEGER             P2(1)
C
      INDEXP = 0
      CH2 = CHGET3(P2,I2)
      J1 =I1
      N20001=I1+L1-L2
      GO TO 20002
20001 J1 =J1 +1
20002 IF ((N20001-J1 ).LT.0) GO TO 20003
      IF (.NOT.(CHGET3(P1,J1) .EQ. CH2)) GO TO 20005
      J2 =I2+1
      N20008=I2+L2-1
      GO TO 20009
20008 J2 =J2 +1
20009 IF ((N20008-J2 ).LT.0) GO TO 20010
      IF (CHGET3(P1,J1+J2-I2) .NE. CHGET3(P2,J2)) GO TO 20001
      GO TO 20008
20010 INDEXP = J1
      GO TO 20004
20005 CONTINUE
20006 GO TO 20001
20003 CONTINUE
C
20004 RETURN
      END
