C-fpp- =================================================================
C-fpp- fpp -- C version 1.0.5 [06-Apr-1991]
C-fpp- Date: Wed Aug 14 17:18:11 1991
C-fpp- Directory: /export/local/sun4/plot79/sf3dir
C-fpp- User: Nelson H.F. Beebe <beebe@csc-sun.math.utah.edu>
C-fpp- Macro: _OS_UNIX=1
C-fpp- Macro: _BSD=1
C-fpp- Macro: _SUN=1
C-fpp- Macro: _SUN4=1
C-fpp- Macro: _BIG_ENDIAN=1
C-fpp- Macro: _IEEE_754=1
C-fpp- Macro: _NAMELIST=1
C-fpp- =================================================================
      SUBROUTINE SYSLOG (LIST,LENLST)
C#if _OS_TOPS20
C##C$    (WRITE SYSTEM LOG)
C##C$    THIS ROUTINE IS INTENDED TO PROVIDE AN INSTALLATION WITH
C##C$    STATISTICS RELATED TO THE USE OF THE SFTRAN3 PREPROCESSOR.
C##C$    IT IS CALLED EACH TIME THE PREPROCESSOR TERMINATES NORMALLY.
C##C$    THE INFORMATION RECORDED, AND THE METHOD OF RECORDING, IS
C##C$    VERY SYSTEM-DEPENDENT, AND IF DESIRED, THIS ROUTINE MAY
C##C$    SIMPLY BE A DUMMY.
C##C$
C##C$    FOR THE DECSYSTEM-20 IMPLEMENTATION, AN ASSEMBLY-LANGUAGE
C##C$    ROUTINE, GETJIN, RETURNS INFORMATION ABOUT THE NAMES OF
C##C$    THE USER AND FILE DIRECTORY, THE RUN TIME, AND WHETHER THE JOB
C##C$    IS RUN INTERACTIVELY, OR IN BATCH.  IN ADDITION, AN INTEGER
C##C$    VECTOR, LIST(*), PROVIDED BY THE CALLING ROUTINE IS WRITTEN TO
C##C$    THE STATISTICS FILE.  THE CONTENTS OF THIS ARE DETERMINED
C##C$    BY THE CALLING ROUTINE, AND ARE NOT EXAMINED HERE.
C##C$    (07-JUL-79)
C##      INTEGER          DATSTR(2),   DIRNO,       DIRSTR(10),  ERROR
C##      INTEGER          JOBNO,       LENDIR,      LENLST,      LENUSR
C##      INTEGER          LIST(LENLST),LOGFIL,      PRGNAM(2),   TERMNO
C##      INTEGER          TIMSTR(2),   USERNO,      USERST(10)
C##      REAL             RUNLIM,      RUNTIM
C##      LOGICAL          BATCH,       FAIL
C##      DATA LOGFIL/63/
C##      CALL GETJIN (ERROR,USERNO,DIRNO,JOBNO,TERMNO,USERST,
C##     X             LENUSR,DIRSTR,LENDIR,PRGNAM,RUNTIM,RUNLIM,BATCH)
C##      IF (ERROR .EQ. 0) THEN
C##           CALL SYSOPN (LOGFIL,7HSF3.STA,4HHLP:,6HAPPEND,
C##     X          5HASCII,4HSAVE,FAIL)
C##           IF (.NOT.FAIL) THEN
C##                CALL DATE (DATSTR)
C##                CALL TIME (TIMSTR(1),TIMSTR(2))
C##                WRITE (LOGFIL,1000) DATSTR,TIMSTR,PRGNAM,USERNO,
C##     X               DIRNO,JOBNO,TERMNO,BATCH,LENUSR,USERST,LENDIR,
C##     X               DIRSTR,LENLST,LIST
C##                CALL SYSCLS (LOGFIL)
C##           END IF
C##      END IF
C##      RETURN
C## 1000 FORMAT (1X, 70(1H=)/
C##     X        1X, 2A5, 2A5, 2A5, 2O14, 2I5, L5/
C##     X        1X, I5, 5X, 10A5/
C##     X        1X, I5, 5X, 10A5/
C##     X        (1X, 7I10))
C##
C#else
      INTEGER             LENLST,      LIST(1)
C
      RETURN
C#endif
      END
